//NES

#include <stdio.h>
#include <stdint.h>
#include "device_io.h"

void main (int argc,  char* argv[])
{ 
 	int clk = 3;
   int latch = 2;
   int data1 = 1;
   int data0 = 0;
   int i;
	uint16_t pad0;
	uint16_t pad1;
	uint16_t value;

	Out(latch, 1);
	Out(clk,0);

   for(;;)
	{
		value = 0;
		Out(latch, 0);
	   pad0 = ShiftIn(data0, clk, LSBPRE, 8); 
	   Out(latch, 1);
      Out(latch, 0);
	   pad1 = ShiftIn(data1, clk, LSBPRE, 8); 
	   Out(latch, 1);

		if (pad1 != 0)
			value = (~pad1 << 8) & 0xFF00;
		if (pad0 != 0)
	   	value |= ~pad0 & 0x00FF;


	   for (i = 0; i < 16; i++)
		{
			if ((value >> i) & 1)
			{
				switch(i)
				{
					case 0:
						printf("Pad 0 A Pressed\n");
					   break;
					case 1:
						printf("Pad 0 B Pressed\n");
					   break;
					case 2:
						printf("Pad 0 Select Pressed\n");
					   break;
					case 3:
						printf("Pad 0 Start Pressed\n");
					   break;
					case 4:
						printf("Pad 0 Up Pressed\n");
					   break;
					case 5:
						printf("Pad 0 Down Pressed\n");
					   break;
					case 6:
						printf("Pad 0 Left Pressed\n");
					   break;
					case 7:
						printf("Pad 0 Right Pressed\n");
					   break;
					case 8:
						printf("Pad 1 A Pressed\n");
					   break;
					case 9:
						printf("Pad 1 B Pressed\n");
					   break;
					case 10:
						printf("Pad 1 Select Pressed\n");
					   break;
					case 11:
						printf("Pad 1 Start Pressed\n");
					   break;
					case 12:
						printf("Pad 1 Up Pressed\n");
					   break;
					case 13:
						printf("Pad 1 Down Pressed\n");
					   break;
					case 14:
						printf("Pad 1 Left Pressed\n");
					   break;
					case 15:
						printf("Pad 1 Right Pressed\n");
					   break;
				
				}
			}
		}

		Delay(20000000);
	}
	
}
